import os

class GraphicsBlock():
    def __init__(self, name, feature="FEAT_TRAINS"):
        self.name = name
        self.out = []
        self.out.append("item({}, item_{}) {{\n    graphics {{".format(
            feature, self.name))

    def add(self, case, stuff):
        self.out.append("        {}: {};".format(case, stuff))

    def __str__(self):
        self.out.append("    }\n}")
        return '\n'.join(self.out)

class Switch():
    def __init__(self, name, var, feature="FEAT_TRAINS"):
        self.header = "switch ({}, SELF, {},\n        {}) {{".format(
            feature, name, var)
        self.inner = []

    def add(self, content):
        self.inner.append("    {};".format(content))

    def __str__(self):
        out = [self.header]
        out.extend(self.inner)
        out.append("}")
        return '\n'.join(out)

class Spriteset():
    realsprites_purchase = [176, 0, 64, 16, -30, -12]
    def __init__(self, name, source, layout="", l=8):
        self.name = name
        self.source = os.path.join("build", source[0])
        self.out = []
        try:
            if source[1] == 4:
                layout = "4_views"
        except IndexError:
            pass
        realsprites_first_4_views = [
            [0,            0, 8,            24, -3,            -12],
            [9 + (8-l)*2,  0, 22 - (8-l)*2, 20, -14 + (8-l)*2, -12],
            [32 + (8-l)*4, 0, 32 - (8-l)*4, 16, -16 + (8-l)*4, -12],
            [65 + (8-l)*2, 0, 22 - (8-l)*2, 20, -6 + (8-l)*2,  -12]
        ]
        realsprites_last_4_views = [
            [88,           0, 8,            24, -3,            -12],
            [97,           0, 22 - (8-l)*2, 20, -14,           -12],
            [120,          0, 32 - (8-l)*4, 16, -16,           -12],
            [153,          0, 22 - (8-l)*2, 20, -6,            -12]
        ]
        self.out.append('spriteset ({}, "{}") {{'.format(
            name, self.source))
        if layout != "purchase":
            for i in realsprites_first_4_views:
                self.out.append("    {}".format(repr(i)))
            if layout != "4_views":
                for i in realsprites_last_4_views:
                    self.out.append("    {}".format(repr(i)))
        elif layout == "purchase":
            self.out.append("    {}".format(self.realsprites_purchase))
    def __str__(self):
        self.out.append("}")
        return '\n'.join(self.out)
